# -*- coding: utf-8 -*-

"""Main module."""
import random
from time import sleep

import discord
from discord.ext import commands

import os
import requests

from subprocess import *

from sys import argv

import aiocron

class Mybot(commands.Cog):
    def __init__(self, bot):
        self.bot = bot

    @commands.command()
    async def join(self, ctx):
        channel = [x for x in self.bot.get_all_channels() if x.name == "Général"][0]
        await channel.connect()
        sleep(2)

    @commands.command()
    async def disconnect(self, ctx):
        await ctx.guild.voice_client.disconnect()

    @commands.command()
    async def welcome(self, ctx):
        if ctx.message.author.name == self.bot.user.name:
            return
        user = ctx.message.author.name
        audio_file = random.choice([f for f in os.listdir('/home/mika/kabot/kabot/kabot/Audio/%s/' % user) if f.endswith('.mp3')])
        source = discord.PCMVolumeTransformer(discord.FFmpegPCMAudio("/home/mika/kabot/kabot/kabot/Audio/%s/%s" % (user,audio_file)))
        ctx.voice_client.play(source, after=lambda e: print('Player error: %s' % e) if e else None)

    @commands.command(help='Update local repo')
    async def update(self, message):
        output = Popen('git pull'.split(), stdout=PIPE).communicate()[0]
        await message.channel.send(output.decode('utf-8'))

    @commands.command(help='Restart Bot')
    async def restart(self, ctx):
        await self.bot.logout()

    @commands.command(help='check if bot always online')
    async def ping(self, message):
        await message.channel.send('pong')

    @commands.command(help="optionnal args : [livre] [character]")
    async def kaamelott(self, ctx, *args):
        response = None
        url = 'https://kaamelott.chaudie.re/api/random'
        if args and ctx.message.content:
            args = list(args)
            if args[0].isdigit():
                livre = int(args[0])
                args.pop(0)
            elif args[-1].isdigit():
                livre = int(args[-1])
                args.pop(-1)
            else:
                livre = None
            if args:
                perso = ' '.join(args)
            if perso and livre:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s/personnage/%s' % (livre,perso)
            elif perso:
                url = 'https://kaamelott.chaudie.re/api/random/personnage/%s' % perso
            else:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s' % livre
        try:
            print(url)
            citation = requests.get(url).json()['citation']
            print(citation)
            response = "%s :\n```\n%s\n```" % (citation['infos']['personnage'], citation['citation'])
            print(response)
        except:
            response = "Unknow error, try: !kaamelott [livre] [character]"
        await ctx.send(response)


def main():
    token = "NjI3MTM3NDY1MDA5ODMxOTQ2.XY4Raw.pw8sAen3bNR5aYsoTChQOudM0L8"
    bot = commands.Bot(command_prefix='!')

    test = False
    if "test" in argv[-1]:
        test=True

    @bot.event
    async def on_ready():
        print('yeah baby!')
        if test:
            await bot.logout()
        for channel in bot.get_all_channels():
            if channel.name == "général":
                current_chan = channel
        await current_chan.send('Le troll est dans la place !')
        ctx = await bot.get_context(current_chan.last_message)
        join = bot.get_command('join')
        await join.invoke(ctx)

    @aiocron.crontab('50 9-23/1 * * *')
    async def kron():
        if choice([True,True,False]):
            for channel in bot.get_all_channels():
                if channel.name == "général":
                    current_chan = channel
            ctx = await bot.get_context(current_chan.last_message)
            ctx.message.content = ""
            print(ctx.message.content)
            kaamelott = bot.get_command('kaamelott')
            await kaamelott.invoke(ctx)

    @bot.event
    async def on_message(message):
        print(message.content)
        if message.author == bot.user:
            return
        else:
            if bot.user in message.mentions \
                    and len(message.mentions) < 3 \
                    and len(message.content.splitlines()) == 1:
                path = '/tmp/%s.log' % message.channel
                with open(path, 'r') as f :
                    lines = f.read().splitlines()
                if not message.content in lines:
                    with open(path, 'a') as f :
                        f.write(message.content + '\n')
                response = random.choice(lines).replace(str(bot.user.id), str(message.author.id))
                await message.channel.send(response)
        await bot.process_commands(message)
    
    @bot.event
    async def on_voice_state_update(member,before,after):
        if before.channel is None and after.channel:
            for channel in bot.get_all_channels():
                if channel.name == "général":
                    current_chan = channel
            ctx = await bot.get_context(current_chan.last_message)
            ctx.message.author = member
            welcome = bot.get_command('welcome')
            sleep(2)
            await welcome.invoke(ctx)

    bot.add_cog(Mybot(bot))
    bot.run(token)


if __name__ == "__main__":
    main()

